<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Session;
use Response;
use Illuminate\Support\Facades\Validator;
use App\User;

class AdminauthController extends Controller
{
    public function index() {
    	if (Auth::guest()) {
	    	return redirect(url('/admin/login'));
    	} else {
    		$user = Auth::user();
    		if($user->role == 1) {
    			return redirect(url('/admin/dashboard'));
    		} else {
    			return redirect(url('/'));
    		}
    	}
    }

    public function login() {
    	if (Auth::guest()) {
	    	return view('admin/login');
    	} else {
    		$user = Auth::user();
    		if($user->role == 1) {
    			return redirect(url('/admin/dashboard'));
    		} else {
    			return redirect(url('/'));
    		}
    	}
    }

    public function loginpost(Request $request) {
    	$credentials = $request->only('email', 'password');
        if(Auth::attempt($credentials)) {
	        Session::save();
			
	        $user = Auth::user();
	        if($user->role == 1) {
				$res['success'] = 1;
				$res['error'] = 0;
				$res['msg'] = 'Login Successful';
				$res['url'] = url('/admin/dashboard');

				return response()->json($res);
				die();
	        }
        } 
		
		$res['success'] = 0;
		$res['error'] = 1;
		$res['msg'] = 'Invalid Admin Credentials';
		echo json_encode($res);
		die();
    }
}
