<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Session;
use Response;
use Illuminate\Support\Facades\Validator;
use App\Penny;
use App\User;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $user = auth()->user();
        $PennyData = Penny::where('auction_category','=','PennyAuction')->where('is_publish','=',0)->orderBy('id', 'DESC')->get();
        $LowestData = Penny::where('auction_category','=','LowestAuction')->where('is_publish','=',0)->orderBy('id', 'DESC')->get();
        return view('front/home', compact(array('PennyData','LowestData')));
    }

    public function userregister() {
        if(Auth::check()){
            return redirect(url('/'));
        }
        return view('front/register');
    }

    public function registersubmit(Request $request) {
        $data = $request->all();

        $validation = Validator::make($data, [
            'email' => ['required', 'string', 'email', 'max:255', 'unique:users'],
            'username' => ['required', 'string', 'max:255', 'unique:users']
        ]);

        if ($validation->fails()) {
            $errors = $validation->errors();
            if(!empty($errors->get('email'))) {
                $res['success'] = 0;
                $res['error'] = 1;
                $res['msg'] = 'Email already exist';

                echo json_encode($res);
                die();
            }

            if(!empty($errors->get('username'))) {
                $res['success'] = 0;
                $res['error'] = 1;
                $res['msg'] = 'Username already exist';

                echo json_encode($res);
                die();
            }
        }

        $password = $data['password'];

        $data['password'] = Hash::make($data['password']);
        $data['name'] = $data['first_name'].' '.$data['last_name'];
        unset($data['re_password']);

        $user = User::create($data);

        $url = url('/verify-email/'.base64_encode($user->id));

        $body = '<div align="center"><table border="0" cellspacing="0" cellpadding="0" style="background:#eeeeee"><tbody><tr><td style="padding:.75pt .75pt 10.5pt .75pt; padding-bottom: 0" ><p class="MsoNormal"> <a href="'.url('/').'" target="_blank"> <img border="0" src="'.url('/public/front/images/logo.png').'" style="height:50px; width: auto;" align="left" alt="HotBids" class="CToWUd"> </a></p></td></tr><tr><td style="border:solid #e4e4e4 1.0pt;background:white;padding:7.5pt 22.5pt 7.5pt 22.5pt"><div align="center"><table border="0" cellpadding="0"><tbody><tr><td style="padding:.75pt .75pt .75pt .75pt"><div><p class="MsoNormal"><span style="color:#666666">Dear<strong>&nbsp;'.$user->username.'</strong>,<br><br>Thank You very much for registering with us. Everyone at <b>HotBids</b>&nbsp;welcomes you as a Valued Member. To ensure you get the most out of your experience, we have included some useful information below. You may wish to keep this email for future reference.<u></u><u></u></span></p></div><div><p class="MsoNormal"><span style="color:#666666">&nbsp;<u></u><u></u></span></p></div><div><p class="MsoNormal"><strong><span style="color:#666666">Your Login Details to access your HotBids.in Account :</span></strong><span style="color:#666666"><u></u><u></u></span></p></div><div><p class="MsoNormal"><span style="color:#666666">&nbsp;<u></u><u></u></span></p></div><div><p class="MsoNormal"><span style="color:#666666">Username:&nbsp;'.$user->username.'<br>Password:&nbsp;* **** (hidden&nbsp;for security purposes)&nbsp;<u></u><u></u></span></p></div><div><p class="MsoNormal"><span style="color:#666666">&nbsp;<u></u><u></u></span></p></div><div><p class="MsoNormal"><strong><span style="color:#666666">To verify this email address belongs to you, click the link below:</span></strong><span style="color:#666666"><u></u><u></u></span></p></div><p class="MsoNormal" align="center" style="text-align:center"> <span style="color:#666666"> <br> <a href="'.$url.'" target="_blank"> <strong> <span style="font-size:11.5pt;color:white;border:solid #cccccc 4.5pt;padding:4.0pt;background:#ff6600">Verify Email - Get Free Bids</span> </strong> </a> </span></p><p> <span style="color:#666666">&nbsp;<u></u><u></u></span></p><p> <span style="color:#666666"><br>&nbsp;We are here to handle all your queries regarding HotBids.in on </span> <b><i><span style="color:blue"><a href="mailto:support@hotbids.in" target="_blank">support@hotbids.in</a></span></i></b> <span style="color:#666666"><u></u><u></u></span></p><p><span style="color:#666666">&nbsp; &nbsp;<u></u><u></u></span></p><p><strong><span style="color:#666666">Keep in touch:</span></strong><span style="color:#666666"><u></u><u></u></span></p><p> <span style="color:#666666">You can follow our updates, announcements and promotions on&nbsp;<a href="javascript:void(0)" target="_blank">Twitter</a>&nbsp;and&nbsp;<a href="javascript:void(0)" target="_blank">Facebook</a>.&nbsp;<u></u><u></u></span></p><p><span style="color:#666666"><u></u>&nbsp;<u></u></span></p><p><span style="color:#666666"><u></u>&nbsp;<u></u></span></p><p> <span style="color:#666666">Happy Bidding!<br><br> <strong>Regards</strong> <br>Team HotBids<br> <br>Questions? Visit our&nbsp;<a href="javascript:void(0)" target="_blank">FAQ\'s</a>&nbsp;&nbsp;Or&nbsp;<a href="javascript:void(0)" target="_blank" >Contact Us</a>.<u></u><u></u> </span></p></td></tr></tbody></table></div></td></tr></tbody></table></div>';

        $credentials = $request->only('email', 'password');
        Auth::attempt($credentials);
        
        Session::save();

        $subject = 'Thank You for Registering with HotBids.in';
        $to = $user->email;
        sendmail($to, $subject, $body);
        
        $res['success'] = 1;
        $res['error'] = 0;
        $res['msg'] = 'Registration Successful';
        $res['url'] = url('/');

        return response()->json($res);
        die();
    }

    public function logout() {
        Session::flush ();
        Auth::logout ();
        return redirect(url('/'));
    }

    public function verifyemail($id) {
        $id = base64_decode($id);
        $user = User::whereId($id)->first();
        if(!empty($user)) {
            if($user->email_verified_at == NULL) {
                User::whereId($id)->update(array('email_verified_at'=>date('Y-m-d h:i:s')));

                $type = 'success';
                $msg = 'Account activated successfully';
            } else {
                $type = 'danger';
                $msg = 'Account already activated';    
            }
        } else {
            $type = 'danger';
            $msg = 'User is not authenticated';
        }

        return view('front/verifyemail', compact('type', 'msg'));
    }

    public function checkRunTime(Request $request) {
        $post = $request->all();
        $row = User::where($post['field'], $post['value'])->first();
        if(!empty($row)) {
            $res['success'] = 0;
            $res['error'] = 1;
            $res['msg'] = 'This '.ucwords($post['field']).' already taken. Try another.';
        } else {
            $res['success'] = 1;
            $res['error'] = 0;
            $res['msg'] = 'Congratulation! This '.ucwords($post['field']).' is available to Register.';
        }

        echo json_encode($res);
        die();
    }
}
